/*  util.h --- various utility functions that don't end up in the library

 Copyright (C) 2009 by Walter C. Pelissero

 Author: Walter C. Pelissero <walter@pelissero.de>
 Project: igorplug

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2, or (at
your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.*/

#ifndef _util_h_INCLUDED
#define _util_h_INCLUDED

#include <stdio.h>

#include "igorplug.h"

#define DEFAULT_TOLERANCE 2

typedef enum {false, true} bool;

typedef struct _action_entry
{
  unsigned code_length;
  IRbuffer code;
  unsigned min_pause;
  void *action;
  struct _action_entry *next;
} action_entry;

typedef void *(*action_parser) (char *string);
typedef void (*action_executor) (void *action_data, void *program_data);

void print_packet (const IRbuffer buf, FILE *fp);
action_entry *read_config_file (const char *pathname, action_parser parser);
action_entry *find_action(IRbuffer buffer, action_entry *actions, unsigned tolerance);
/* This is actually in lib.c */
bool compare_codes (IRbyte *c1, IRbyte *c2, unsigned length, unsigned tolerance);
extern bool debug;
void dprint(const char *fmt, ...);
int main_loop (int fd, action_executor execute, action_entry *actions, unsigned tolerance, void *data);

#endif	/* _util_h_INCLUDED */
